Scriptname SSLHaggleOutQuestScript extends Quest  

SexLabFramework Property SLF auto
GlobalVariable Property SSLHOSkillGainMult auto
GlobalVariable Property SpeechSkillMult auto
FavorDialogueScript Property FDS auto
ReferenceAlias Property LastOneRef auto
Faction Property SSLHOConsensualFaction auto
GlobalVariable Property SSLHOPersuasionLevel auto
GlobalVariable Property SSLHOArousedSupport auto
GlobalVariable Property SSLHOCounterpartArousal auto
GlobalVariable Property SSLHOMyArousal auto
GlobalVariable Property SSLHORSSupport auto
Message Property SSLHOStimulationMsg auto
Message Property SSLHOTooEagerMsg auto

Function checkArousal(Actor counterPart)
	SSLHOPersuasionLevel.setValue(Game.getPlayer().getAv("Speechcraft"))
	if (SSLHOArousedSupport.getValue())
		SSLHOCounterpartArousal.setValue((Game.getFormFromFile(0x4290f, "SexlabAroused.esm") as slaFrameworkScr).getActorArousal(counterPart))
		SSLHOMyArousal.setValue((Game.getFormFromFile(0x4290f, "SexlabAroused.esm") as slaFrameworkScr).getActorArousal(Game.getPlayer()))
	else
		SSLHOCounterpartArousal.setValue((100-counterPart.getAv("Speechcraft"))/(1+counterPart.getAv("Morality")))
		SSLHOMyArousal.setValue((100-Game.getPlayer().getAv("Speechcraft"))/(1+counterPart.getAv("Morality")))
	endIf
endFunction

Function startAction(Actor counterPart)
	(LastOneRef as SSLHaggleOutLastOneScript).setLastOne(counterPart)
	if (SSLHOArousedSupport.getValue() && SSLHORSSupport.getValue())
		float aggression = counterPart.getAv("Aggression")+counterPart.getAv("Confidence")+3 - counterPart.getAv("Morality")
		aggression *= aggression/5
		float randomness = Utility.randomFloat(0.0, 100.0)
;debug.notification(randomness+" on "+aggression)
		if ((SSLHOCounterpartArousal.getValue() >= 60 || SSLHOCounterpartArousal.getValue() < 20) && randomness < aggression)
			if (SSLHOCounterpartArousal.getValue() < 20)
				SSLHOStimulationMsg.show()
			else
				SSLHOTooEagerMsg.show()
			endIf
			Spell en = Game.getFormFromFile(0x12c5, "SexLabRapeSpell.esp") as Spell
			en.cast(counterPart, Game.getPlayer())
			return
		endIf
	endIf
	Actor [] actors = new Actor [2]
	if (SLF.getGender(counterPart) == 1)
		actors[0] = counterPart
		actors[1] = Game.getPlayer()
	elseIf (SLF.getGender(Game.getPlayer()) == 1)
		actors[0] = Game.getPlayer()
		actors[1] = counterPart
	else
		actors[0] = counterPart
		actors[1] = Game.getPlayer()
	endIf
	String tags = ""
	if (SLF.getGender(actors[1]) != SLF.getGender(actors[0]))
		tags = "MF"
	else
		if (SLF.getGender(actors[1]) == 0)
			tags = "Gay,Anal"
		else
			tags = "Lesbian"
		endIf
	endIf

	sslBaseAnimation [] sba = SLF.getAnimationsByTags(2, tags, "LeadIn,Aggressive", true)
	int retval = SLF.startSex(actors, sba)
	if (retval == -1)
		debug.notification("SexLab HaggleOut: interrupted")
		clearLastOne()
	endIf
endFunction

Function persuade(Actor akSpeaker)
	float s = SpeechSkillMult.getValue()
	SpeechSkillMult.setValue(akSpeaker.getAv("Speechcraft")*SSLHOSkillGainMult.getValue())
	FDS.persuade(akSpeaker)
	SpeechSkillMult.setValue(s)
endFunction

Function intimidate(Actor akSpeaker)
	float s = SpeechSkillMult.getValue()
	SpeechSkillMult.setValue(akSpeaker.getAv("Speechcraft")*SSLHOSkillGainMult.getValue())
	FDS.intimidate(akSpeaker)
	SpeechSkillMult.setValue(s)
endFunction

Function bribe(Actor akSpeaker)
	float s = SpeechSkillMult.getValue()
	SpeechSkillMult.setValue(akSpeaker.getAv("Speechcraft")*SSLHOSkillGainMult.getValue())
	FDS.bribe(akSpeaker)
	SpeechSkillMult.setValue(s)
endFunction

Function clearLastOne()
	LastOneRef.clear()
endFunction

Function ascendConsensuality(Actor akSpeaker)
	if (akSpeaker.isInFaction(SSLHOConsensualFaction))
		akSpeaker.modFactionRank(SSLHOConsensualFaction, 1)
	else
		akSpeaker.setFactionRank(SSLHOConsensualFaction, 1 + akSpeaker.getRelationshipRank(Game.getPlayer())*10)
	endIf
	if (((akSpeaker.getFactionRank(SSLHOConsensualFaction)/10) as int) > akSpeaker.getRelationshipRank(Game.getPlayer()) && akSpeaker.getRelationshipRank(Game.getPlayer()) < 4)
		akSpeaker.setRelationshipRank(Game.getPlayer(), ((akSpeaker.getFactionRank(SSLHOConsensualFaction)/10) as int))
	endIf
endFunction